

class Sb_Actel
{
  public:
    Sb_Actel(); //constructor
    ~Sb_Actel(); //destructor    

    bool send_25ns_pulse(int node_id, int i2c_ch, BYTE DAC_value);
	bool send_long_pulse(int node_id);
	bool send_1000long_pulse(int node_id);
	bool send_40M_clk(int node_id);
	bool send_clk(int node_id, int i2c_ch, int counter_nr, int *value);
	bool select_swpulse_mode(int node_id);
	bool select_sw_start_stop_mode(int node_id);
	bool set_tmis_time_ms(int node_id, int time);
	bool write_ADDR_PULSE(int node_id);

  private:
  BYTE data[4];
  int index_actel;
  BYTE can_msg_cnf[4];
};


//////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////ACTEL////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

//index ACTEL addr
#define ACTEL_ADDR				0x4700

//subindex (actel registers)
#define ADDR_TEST_PULSE_SEL		0 
#define ADDR_TDIV				1
#define ADDR_INT_PULSE_SEL		2
#define ADDR_PULSE				3
#define ADDR_TMIS_L				4	
#define ADDR_TMIS_H				5
#define ADDR_TDLY				6
#define ADDR_PLSMSK0			7
#define ADDR_PLSMSK1			8
#define ADDR_DEV				9
#define ADDR_VERS				10
#define ADDR_ACTEL_Day			11
#define ADDR_ACTEL_Month		12
#define ADDR_ACTEL_Year			13
#define ADDR_ACTEL_PRESCAL_L	14
#define ADDR_ACTEL_PRESCAL_H	15
#define ADDR_ACTEL_RESET_L		14
#define ADDR_ACTEL_RESET_H		15

//value for subindex ADDR_TEST_PULSE_SEL
#define INT_PULSE				0
#define CLK40					1
#define BC_PULSE				2
#define REG_PULSE				3

//value for subindex ADDR_INT_PULSE_SEL
#define DIV_PULSE				0
#define DLY_PULSE				1
#define SW_PULSE				2
#define ASYNC_START_STOP		4
#define SYNC_START_STOP			5
#define SW_START_STOP			6