
//#include <stream.h>
#include <stdlib.h>
#include <time.h>

#include <iostream>
#include <windows.h>
#include "threads.h"
#include "canopen_custom.h"
#include "test_routines.h"
#include "resource.h"
#include "sb_actel.h"
#include "test_station_func.h"
#include "graphics.h"
#include "math.h"

using namespace std;

ThreadClass::ThreadClass() //constructor
{
	//initialize variables
	m_dwThreadID = 0;
    m_hThread    = 0;
}
ThreadClass::~ThreadClass() //destructor
{
	CloseHandle(m_hThread);
}


/*bool ThreadClass::Create_Thread(DWORD func_nr) //DWORD = 4 bytes
{
    m_hThread = CreateThread(0,
                             0,
                             ThreadFunc,
                             (LPVOID)func_nr,//this,
                             0,
                             &m_dwThreadID);
    if(!m_hThread)
    {
      // Could not create thread
      return false;
    }
    return true;              
}*/

bool ThreadClass::run_cardiac_find_th_zero(BYTE node_id, BYTE time) //DWORD = 4 bytes
{
	DWORD Param;
	Param =(0<<24)|(node_id<<8)|(time);

    m_hThread = CreateThread(0,
                             0,
                             ThreadFunc,
                             (LPVOID)Param,//this,
                             0,
                             &m_dwThreadID);
    if(!m_hThread)
    {
      // Could not create thread
      return false;
    }
    return true;              
}

HANDLE ThreadClass::run_scurve() //DWORD = 4 bytes
{
	DWORD Param;
	Param =(1<<24);

    m_hThread = CreateThread(0,
                             0,
                             ThreadFunc,
                             (LPVOID)Param,//this,
                             0,
                             &m_dwThreadID);
    if(!m_hThread)
    {
      // Could not create thread
      return false;
    }
    return m_hThread;              
}



DWORD WINAPI ThreadClass::ThreadFunc(LPVOID pvParam)
{		
	BYTE func_nr = ((DWORD)pvParam>>24)&0xFF;

	switch((BYTE)func_nr)
	{
	   case 0: //cardiac_find_th_zero(int time, int node_id);
		{			
			BYTE node_id = ((DWORD)pvParam>>8)&0xFF;
			BYTE time = ((DWORD)pvParam)&0xFF;

			extern HWND g_hElmbDialog;
			extern unsigned int FE_Array[65];
			extern LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

			bool b = FALSE;
			HWND hEdit = GetDlgItem(g_hElmbDialog, IDC_FESCAN_MSG);
			HWND g_hWaitBox;
			

				g_hWaitBox = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_WAITBOX), g_hElmbDialog, (DLGPROC)About);
				if(g_hWaitBox != NULL)
					ShowWindow(g_hWaitBox, SW_SHOW);
				else
				 	MessageBox(g_hElmbDialog, "CreateDialog Returned NULL", "Warning!", MB_OK | MB_ICONINFORMATION);
							
				if (FE_Array[0] == 0xAA)
				{
					MessageBox(NULL, "To use this feature you must do a 'FE Scan'\r\nRemember to 'Sent to Operational' the CANnode", "WRONG PARAMETER", MB_ICONEXCLAMATION | MB_OK);
					DestroyWindow(g_hWaitBox);
					break;
				}
				if (time == 0)
				{
					MessageBox(NULL, "Time parameter must be higher than zero", "WRONG PARAMETER", MB_ICONEXCLAMATION | MB_OK);
					DestroyWindow(g_hWaitBox);
					break;
				}				
				if(node_id==0)
				{					
					int i;
					i = MessageBox(NULL, "Are you sure you want to submit all channels to this procedure?\r\nIf not set a value to the NodeID parameter", "ATTENTION", MB_YESNO);					
					if(i==IDNO)
					{
						DestroyWindow(g_hWaitBox);
						break;
					}
				}
				
				SendMessage(hEdit, EM_REPLACESEL, (WPARAM) FALSE, (LPARAM)"---------------------------------------\r\n");					
				SendMessage(hEdit, EM_REPLACESEL, (WPARAM) FALSE, (LPARAM)"find FE offset...wait\r\nMake sure all excell test files are closed\r\n"); //to append a text
				
				if(node_id==0)
				{					
					for( node_id=1; node_id<64; ++node_id ) // to set all nodes!!
							b = (b | cardiac_find_th_zero(time, node_id));
				}
				else b = cardiac_find_th_zero(time, node_id);//cardiac_find_th_zero(time, node_id);
				
				if (b == TRUE) SendMessage(hEdit, EM_REPLACESEL, (WPARAM) FALSE, (LPARAM)"files have been created in: C:\\LHCbTests\r\n");			
				else SendMessage(hEdit, EM_REPLACESEL, (WPARAM) FALSE, (LPARAM)"None front-end board found\r\n");

				SendMessage(hEdit, EM_REPLACESEL, (WPARAM) FALSE, (LPARAM)"find FE offset...finished\r\n");
				SendMessage(hEdit, EM_REPLACESEL, (WPARAM) FALSE, (LPARAM)"---------------------------------------\r\n");
				DestroyWindow(g_hWaitBox);

		}
	   break;

	   case 1: //scan for scurve (test station)
	   {		
			int value, init, end, step, i, inj_ch;
			bool ch_mask[16];
			Sb_Actel sb_ac;
			Test_Station ts;
			Dialog dialog;
			static graph2D testing;// it was static before maybe...
			extern HWND g_hScurveDialog;
			int fe_addr, node_id_fe, i2c_ch_fe, node_id_inj, i2c_ch_inj;
			HWND hPicture = GetDlgItem(g_hScurveDialog, IDC_PICTURE_STATIC);
			testing.select_frame(hPicture);
			char * str1 = new char[20];
			{
			   int a, b;
			   // fe_addr
			   GetDlgItemText(g_hScurveDialog, IDC_SC_COMBOBOX_FE_ADDR, str1, 18);
			   sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id_fe, &i2c_ch_fe, &fe_addr);

			   // test_station addr
			   GetDlgItemText(g_hScurveDialog, IDC_SC_COMBOBOX, str1, 18);
			   sscanf(str1, "NodeID%02d_I2C%d", &node_id_inj, &i2c_ch_inj);
			}

			init = GetDlgItemInt(g_hScurveDialog, IDC_SCURVE_INIT, NULL, NULL);
			end = GetDlgItemInt(g_hScurveDialog, IDC_SCURVE_END, NULL, NULL);
			step = GetDlgItemInt(g_hScurveDialog, IDC_SCURVE_STEP, NULL, NULL);
			inj_ch = GetDlgItemInt(g_hScurveDialog, IDC_SC_CHANNEL, NULL, NULL);

			//set default
			if(!dialog.set_default(node_id_fe, i2c_ch_fe, fe_addr))
			{	
			  MessageBox(g_hScurveDialog, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
			  break;
			}

			//set DIALOG MASK to this channel (inj_ch)
			for(i=0;i<=15;i++) ch_mask[i] = FALSE;
			ch_mask[inj_ch] = TRUE;					
			if(!dialog.set_mask(node_id_fe, i2c_ch_fe, fe_addr, ch_mask))
			{	
			  MessageBox(g_hScurveDialog, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
			  break;
			}

			//set TS MASK (PCF8575) to this channel (inj_ch)
			if(!ts.set_mask(node_id_inj, i2c_ch_inj, ch_mask))
			{	
			  MessageBox(g_hScurveDialog, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
			  break;
			}

			for(i=init; i<= end; i+=step)
			{
				SetDlgItemInt(g_hScurveDialog, IDC_CURRENT_VALUE, i, FALSE);
				//set DAC value
				if(!ts.write_dac(node_id_inj, i2c_ch_inj, i))
				{	
				  MessageBox(g_hScurveDialog, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
				  break;
				}
						
			    //reset counters						
			    ts.reset_counters(node_id_inj, i2c_ch_inj);

			    //send 1000 pulses
			    sb_ac.send_1000long_pulse(node_id_inj);
				

			    //read counters
			    ts.read_counter(node_id_inj, i2c_ch_inj, floor(inj_ch/2), &value); //ch3				

			    testing.add_point(value, 10);
			    testing.update();
			}	
					
			return TRUE;
		}		   
	   break;
	}
	return 1;
}