// win32app_test4.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "stdio.h"
#include "resource.h"
#include "math.h"
#include "commctrl.h"
#include <process.h>

#include "process_can.h"
#include "canopen.h"
#include "elmb.h"
#include "test_routines.h"
#include "canopen_custom.h"
#include "variables_custom.h"
#include "ApiFunctions.h"
#include "i2c_functions.h"
#include "graphics.h"
#include "test_station_func.h"
#include "sb_actel.h"
#include "threads.h"

#define MAX_LOADSTRING 100

CAN_INTERFACE_TYPE CanInterface;
// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];
TCHAR g_szChildClassName[MAX_LOADSTRING];// = "ClientWindowClass";

HWND g_hToolbar = NULL;
HWND g_hToolbar2 = NULL;
HWND g_hMDIClient = NULL;
HWND hChild = NULL; // it shouldnt be global but I have to learn hot to get its handle
   							// The title bar text
HWND g_hMain;
HWND g_hElmbDialog;
HWND g_hCardiacDialog;
HWND g_hTestStationDialog;
HWND g_hScurveDialog;
unsigned int FE_Array[65]; //taking in account that it will me a maximum of 64 Nodes (1-64)
bool ELMB_Array[65];

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	MDIChildWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	HelpProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	ElmbPanel(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	CardiacReadWrite(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	CANopen_TextOut(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	TestStationProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	ScurveProc(HWND, UINT, WPARAM, LPARAM);

void Bounce( void *ch );//lixo

HWND CreateNewMDIChild(HWND);

int /*APIENTRY*/ WINAPI WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;
	int            poll_result;
	CAN_FRAME_TYPE can_frame;

	 /* Commandline parameters */
  char           interface_id = '0';
  int            autoload     = FALSE;
  char           *filename;
  int            verify       = FALSE;
  bool loopcheck = 1;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WIN32APP_TEST4, szWindowClass, MAX_LOADSTRING);
	LoadString(hInstance, ID_MDI_FIRSTCHILD, g_szChildClassName, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WIN32APP_TEST4);	

	hChild = CreateNewMDIChild(g_hMDIClient); //create child panel (CAN messages)

	// Main message loop:
	while(loopcheck)
	{
		//if(GetMessage(&msg, NULL, 0, 0)) 
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			if (msg.message == WM_QUIT)
			{
				loopcheck = false;
			}
			//loopcheck = GetMessage(&msg, NULL, 0, 0);
			if (!TranslateMDISysAccel(g_hMDIClient, &msg)) 
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}	

	//	MessageBox(NULL, "error", "errror", 1);
		
		/* Poll the interface for a CAN message */
		poll_result = poll_can_msg( CanInterface, &can_frame );

		if( poll_result == CAN_SUCCESS )
		{
			++NoRecMsg;
			/* Print/process the message */
			process_can_msg( &can_frame );
		}
		//The code that was here is in the following path:
		//...\win32app_test4\Notes&others\code_C_number1.txt	
	}
	return msg.wParam;	
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 
	wcex.style = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc = (WNDPROC)WndProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hInstance;
	wcex.hIcon = LoadIcon(hInstance, (LPCTSTR)IDI_WIN32APP_TEST4);
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName = (LPCSTR)IDC_WIN32APP_TEST4;
	wcex.lpszClassName = szWindowClass;
	wcex.hIconSm = LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);


	SetLastError(0);
	if(!RegisterClassEx(&wcex)) 
	{
		LPVOID lpMsgBuf;
		if (!FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL ))
		{
		}
	MessageBox(NULL, (LPCTSTR)lpMsgBuf, "Can not register main window", 1);
	LocalFree(lpMsgBuf);
	}

	wcex.cbSize = sizeof(WNDCLASSEX); 
	wcex.style = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc = (WNDPROC)MDIChildWndProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hInstance;
	wcex.hIcon = LoadIcon(hInstance, (LPCTSTR)IDI_WIN32APP_TEST4);//LoadIcon(NULL, IDI_APPLICATION);
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)(COLOR_3DFACE+1);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = g_szChildClassName;
	wcex.hIconSm = LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);//LoadIcon(NULL, IDI_APPLICATION);

	SetLastError(0);
	if(!RegisterClassEx(&wcex))
	{
		LPVOID lpMsgBuf;
		if (!FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL )) 
			{
			}
		MessageBox(NULL, (LPCTSTR)lpMsgBuf, "Can not register child window", 1);
		LocalFree(lpMsgBuf);
	}
	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd; 

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

 /* hwndFrame = CreateWindow (szFrameClass, TEXT ("MDI Demonstration"),
                               WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                               CW_USEDEFAULT, CW_USEDEFAULT,
                               CW_USEDEFAULT, CW_USEDEFAULT,
                               NULL, hMenuInit, hInstance, NULL) ;*/
   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, SW_SHOW);
   UpdateWindow(hWnd);

   g_hToolbar = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MESSAGEBOX),
								hWnd, (DLGPROC)About);
   g_hToolbar2 = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDC_WIN32APP_TEST4),
								hWnd, (DLGPROC)About);   

   g_hMain = hWnd;

   CreateDirectory("C:\LHCbTests", NULL);  //Create files to be used as database
   CreateDirectory("C:\LHCbTests/CARDIAC_GEM", NULL); 
   CreateDirectory("C:\LHCbTests/CARDIAC_MWPC", NULL);


   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];			
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);	

	switch (message) 
	{		
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
					{
						DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
					}
				   break;
				 case ID_ELMB_PANEL:
				{					 
					 //instead of creating a new, I only show the panel which was hiden
					 ShowWindow(g_hElmbDialog, SW_SHOW);

					 //g_hElmbDialog = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ELMBBOX), hWnd, (DLGPROC)ElmbPanel);
					 //if(g_hElmbDialog != NULL)
					//	 ShowWindow(g_hElmbDialog, SW_SHOW);
					 //else
				 	//	 MessageBox(hWnd, "CreateDialog Returned NULL", "Warning!", MB_OK | MB_ICONINFORMATION);

				}
				   break;	
/*				case ID_INIT_CAN:
				{
					// Commandline parameters 
					char           interface_id = '0';
					int            autoload     = FALSE;
					char           *filename;
					int            verify       = FALSE;
					int				argc = 1;
					char			*argv[106];
	
					// Get commandline parameters 

//					get_pars( argc, argv, &NodeID, &interface_id,
//							&autoload, &filename, &verify );
					// Make it possible to use a different interface "CANx" with x=0,1,2,.. 
					CanIntfName[4] = interface_id;
					// Initialize 
					close_can_controller( CanInterface );
					init_can_controller( CanIntfName, Bitrate, &CanInterface);
					return TRUE;
				}
*/
				   break;			   
				case ID_CARDIAC_READWRITE:
				{				
					 g_hCardiacDialog = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_CARDIACBOX), hWnd, (DLGPROC)CardiacReadWrite);
					 if(g_hCardiacDialog != NULL)
						 ShowWindow(g_hCardiacDialog, SW_SHOW);
					 else
				 		 MessageBox(hWnd, "CreateDialog Returned NULL", "Warning!", MB_OK | MB_ICONINFORMATION);

				}
				   break;		
				case ID_CARDIAC_TEST:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case ID_CARDIAC_CALIBRATION:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case ID_RATEMETHOD:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
			   case ID_FILE_NEW:
				{
					//HWND hChild;
					hChild = CreateNewMDIChild(g_hMDIClient);
				}
				
				break;
			    case ID_FILE_OPEN:
					{
						//HWND hChild;
						if(hChild);
							//DoFileOpen(hChild);
					}
//				DoFileOpen(hWnd);				
				break;
				case ID_FILE_SAVEAS:
					{	
						//HWND hChild;
						//if(hChild) SetDlgItemText(hChild, IDC_CHILD_EDIT, "testing");
						//DoFileSave(hWnd);
					}					
				break;
				case IDM_EXIT:					
				   DestroyWindow(hWnd);
				   break;

				case IDM_HELP:
				{
					DialogBox(hInst, (LPCTSTR)IDD_HELPBOX, hWnd, (DLGPROC)HelpProc);					
				}					
				break;
				case ID_TESTSTATION_OPEN:
				{
					g_hTestStationDialog = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_TSTATIONBOX), hWnd, (DLGPROC)TestStationProc);
					if(g_hTestStationDialog != NULL)
						ShowWindow(g_hTestStationDialog, SW_SHOW);
					else
				 		MessageBox(hWnd, "CreateDialog Returned NULL", "Warning!", MB_OK | MB_ICONINFORMATION);	
				}					
				break;
				case ID_SCURVE_PANEL:
				{
					g_hScurveDialog = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_SCURVEBOX), hWnd, (DLGPROC)ScurveProc);
					if(g_hScurveDialog != NULL)
						ShowWindow(g_hScurveDialog, SW_SHOW);
					else
				 		MessageBox(hWnd, "CreateDialog Returned NULL", "Warning!", MB_OK | MB_ICONINFORMATION);	
				}					
				break;
				default:

					//Handle MDI Window commands
				{
					if (LOWORD(wParam) >= ID_MDI_FIRSTCHILD)
						DefFrameProc(hWnd, g_hMDIClient, message, wParam, lParam);
				
					else
					{
						HWND hChild = (HWND)SendMessage (g_hMDIClient, WM_MDIGETACTIVE,0,0);
						if(hChild)
							SendMessage(hChild, WM_COMMAND,wParam, lParam);
					}
				}

				return DefFrameProc(hWnd, g_hMDIClient, message, wParam, lParam);
			}
			break;
			
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
		{
		//	HWND g_hElmbDialog = GetDlgItem(hWnd, IDD_ELMBBOX); //handle ELMB Dialog Box
			DestroyWindow(g_hElmbDialog); // Destroy ELMB Dialog Box
			DestroyWindow(g_hCardiacDialog); // Destroy CardiacReadWrite Dialog Box
			DestroyWindow(g_hTestStationDialog);
			PostQuitMessage(0);	
		}
			break;
		case WM_CREATE:
			{
				CLIENTCREATESTRUCT ccs;

				ccs.hWindowMenu = GetSubMenu(GetMenu(hWnd), 2);
				ccs.idFirstChild = ID_MDI_FIRSTCHILD;				
			

				g_hMDIClient = CreateWindowEx(WS_EX_CLIENTEDGE, "mdiclient", NULL, 
					WS_CHILD|WS_CLIPCHILDREN|WS_VSCROLL|WS_HSCROLL|WS_VISIBLE, 
					CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
					hWnd, (HMENU)IDC_MAIN_MDI, GetModuleHandle(NULL), (LPVOID)&ccs);

				//Init general panel
				{			
					 int i;
					 FE_Array[0] = 0xAA;//this variable must be written at least once before using the cardiac_find_th_zero (to use it the user must do a FE Scan (PDO))
					 for (i=0; i<=64; i++) ELMB_Array[i] = 0;
					 g_hElmbDialog = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ELMBBOX), hWnd, (DLGPROC)ElmbPanel);
					 if(g_hElmbDialog != NULL)
						 ShowWindow(g_hElmbDialog, SW_SHOW);
					 else
				 		 MessageBox(hWnd, "CreateDialog Returned NULL", "Warning!", MB_OK | MB_ICONINFORMATION);
				}

				FE_Array[0] = 0xAA;//this variable must be written at least once before using the cardiac_find_th_zero (to use it the user must do a FE Scan (PDO))
/*
				//Init CAN port
				{
					// Commandline parameters 
					char           interface_id = '0';
					int            autoload     = FALSE;
					char           *filename;
					int            verify       = FALSE;
					int				argc = 1;
					char			*argv[106];
	
					// Get commandline parameters 
					get_pars( argc, argv, &NodeID, &interface_id,
							&autoload, &filename, &verify );
					// Make it possible to use a different interface "CANx" with x=0,1,2,.. 
					CanIntfName[4] = interface_id;
					 Initialize 
					close_can_controller( CanInterface );
					init_can_controller( CanIntfName, Bitrate, &CanInterface);
				}			*/	
				
				return 0;
			}			
			break;
		default:
			return DefFrameProc(hWnd, g_hMDIClient, message, wParam, lParam);
   }
   return 0;
}


LRESULT CALLBACK MDIChildWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

		switch(message)
	{
		case WM_CREATE:
		{
			HFONT hfDefault;
			HWND hEdit;	

			hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", 
				WS_CHILD | ES_MULTILINE | WS_VISIBLE | ES_READONLY | ES_AUTOHSCROLL | WS_HSCROLL |WS_VSCROLL | ES_AUTOVSCROLL,
				0 ,0, 100, 100, hWnd, (HMENU)IDC_CHILD_EDIT, GetModuleHandle(NULL), NULL);
			if(hEdit == NULL)
			MessageBox(hWnd, "not create edit box", "Error", MB_OK | MB_ICONERROR);
			hfDefault = (HFONT)GetStockObject (DEFAULT_GUI_FONT);
			SendMessage(hEdit, WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
		}
		break;
		case WM_MDIACTIVATE:
		{
			HMENU hMenu, hFileMenu;
			UINT EnableFlag;

		//	g_hMainWindow = GetModuleHandle(IDC_WIN32APP_TEST4);
		//	g_hMain = GetModuleHandle(IDC_WIN32APP_TEST4);

			hMenu = GetMenu(hWnd);//hWnd);//g_hMainWindow);
			if(hWnd == (HWND)lParam)
			{
				EnableFlag = MF_ENABLED;
			}
			else
			{
				EnableFlag = MF_GRAYED;
			}

			EnableMenuItem(hMenu, 1, MF_BYPOSITION | EnableFlag);
			EnableMenuItem(hMenu, 2, MF_BYPOSITION | EnableFlag);

			hFileMenu = GetSubMenu (hMenu, 0);
			EnableMenuItem(hFileMenu, ID_FILE_SAVEAS, MF_BYCOMMAND | EnableFlag);

			EnableMenuItem(hMenu, ID_FILE_CLOSE, MF_BYCOMMAND | EnableFlag);
			EnableMenuItem(hMenu, ID_FILE_CLOSEALL, MF_BYPOSITION | EnableFlag);

			DrawMenuBar (hWnd);//hWnd);//g_hMainWindow);
		}
		break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
			case ID_FILE_OPEN:
				MessageBox(NULL, "ID_FILE_OPEN", "ID_FILE_OPEN", 1);

//				DoFileOpen(hWnd);				
			break;
			case ID_FILE_SAVEAS:
//				DoFileSave(hWnd);
			break;
			}
		break;
			case WM_SIZE:
			{
				HWND hEdit;
				RECT rcClient;

				GetClientRect(hWnd, &rcClient);
				hEdit = GetDlgItem(hWnd, IDC_CHILD_EDIT);
				SetWindowPos(hEdit, NULL, 0, 0, rcClient.right, rcClient.bottom, SWP_NOZORDER);
			}
				return DefMDIChildProc(hWnd, message, wParam, lParam);
			default:
				return DefMDIChildProc(hWnd, message, wParam, lParam);

	}	
	return 0;
}


// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

LRESULT CALLBACK HelpProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:	
			{
				char * str1 = new char[100000];
				LoadString( GetModuleHandle(NULL), IDS_HELP, str1, 100000);
				SetDlgItemText(hDlg, IDC_HELP, str1);
				return TRUE;
			}

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

// Mesage handler for ELMB box.
LRESULT CALLBACK ElmbPanel(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) // Default Value
{
	BYTE can_msg_cnf[4];
	BYTE can_msg_rtn[4];
	BYTE message_[4];
	WORD len;
	switch (message)
	{
		case WM_INITDIALOG:	//Default Values
			{
				int i, j;
				char * str = new char[10];
				SetDlgItemInt(hDlg, IDC_TH_SCAN_TIME, 1, FALSE);
				SetDlgItemInt(hDlg, IDC_SENSIT, 0, FALSE);
				CheckRadioButton(hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO1); //set value default				
				if(CheckRadioButton(hDlg, IDC_RadioFLASH, IDC_RadioEEPROM, IDC_RadioFLASH) == 0) //set value default
					MessageBox(NULL, "Error CheckRadioButton IDC_RadioFLASH", "Warning!", 1);

				if(CheckRadioButton(hDlg, IDC_RADIO4, IDC_RADIO5, IDC_RADIO4) == 0) //set value default
					MessageBox(NULL, "Error CheckRadioButton IDC_RADIO4", "Warning!", 1);
				//set comboBoxes
				//SetDlgItemText(hDlg, IDC_COMBO_ELMB, "0");
			/*	for(i=0; i<=64; i++)
				{
					if (i<=9) sprintf(str, "0%d", i);
					else sprintf(str, "%d", i);
					SendDlgItemMessage(hDlg, IDC_COMBO_ELMB, CB_ADDSTRING, 0, 
								(LPARAM) str);				
				}*/
				SetDlgItemInt(hDlg, IDC_COMBO_ELMB, 0, FALSE);				
			}
				return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
			case IDINITCAN:
			{
				HWND hEdit = GetDlgItem(hDlg, IDC_FESCAN_MSG);
				/* Commandline parameters */
				char           interface_id = '0';
				int            autoload     = FALSE;
				char           *filename;
				int            verify       = FALSE;
				int				argc = 1;
				char			*argv[106];

				/* Get commandline parameters */
			//	get_pars( argc, argv, &NodeID, &interface_id,
			//			&autoload, &filename, &verify );
				/* Make it possible to use a different interface "CANx" with x=0,1,2,.. */
				CanIntfName[4] = interface_id;			
				SetDlgItemText(hDlg, IDC_COMBO_ELMB, "0");
				/* Initialize */
				close_can_controller( CanInterface );
				init_can_controller( CanIntfName, Bitrate, &CanInterface);

				//ELMB scan
				SendMessage(hDlg, WM_COMMAND, (WPARAM)ID_EMB_SCAN , (LPARAM)NULL);
				
				//Send to Operational
				SendMessage(hDlg, WM_COMMAND, (WPARAM)ID_SEND_OPERAT , (LPARAM)NULL);

				//FE scan
				SendMessage(hDlg, WM_COMMAND, (WPARAM)ID_FE_SCAN , (LPARAM)NULL);
				Sleep(1000);
				SendMessage(hEdit, EM_REPLACESEL, (WPARAM) FALSE, (LPARAM)"Initializing Program...\r\n");

				set_heartbeat_time(0);
				
				return TRUE;
			}
			break;
			case ID_CLOSECAN:
			{
				close_can_controller( CanInterface );
				return TRUE;
			}
			break;
			case ID_SEND_OPERAT:
			{
				int i;
				i = GetDlgItemInt(hDlg, IDC_COMBO_ELMB, NULL, NULL);
				byte can_data[2];
				can_data[0] = NMT_START_REMOTE_NODE;
				can_data[1] = NodeID; // to a specific node
				can_data[1] = i;  // to all nodes 
				send_can_msg( CanInterface, 0, NMT_OBJ, FALSE, 2, can_data );
				//printf( "Sent NMT-Start-Remote-Node All Nodes...\n\n" ); //###modified NodeID were 0 (tutti)     
				return TRUE;
			}
			break;
			case ID_SEND_PREOP:
			{
				int i;
				i = GetDlgItemInt(hDlg, IDC_COMBO_ELMB, NULL, NULL);
				byte can_data[2];
				can_data[0] = NMT_ENTER_PREOPERATIONAL_STATE;
				can_data[1] = NodeID; // to a specific node
				can_data[1] = i;  // to all nodes 
				send_can_msg( CanInterface, 0, NMT_OBJ, FALSE, 2, can_data );
				return TRUE;
			}
			break;
			case ID_SEND_STOP:
			{
				byte can_data[2];
				int i;
				i = GetDlgItemInt(hDlg, IDC_COMBO_ELMB, NULL, NULL);				
				can_data[0] = NMT_STOP_REMOTE_NODE;
				can_data[1] = NodeID; // to a specific node
				can_data[1] = i;  // to all nodes 
				send_can_msg( CanInterface, 0, NMT_OBJ, FALSE, 2, can_data );
				return TRUE;
			}
			break;
			case ID_FE_SCAN:
			{				
				//PDO4 Scan for Front-end
				byte pdo_data[2];
				int i;
				HWND hEdit = GetDlgItem(hDlg, IDC_FESCAN_MSG);
				SendDlgItemMessage(hDlg, IDC_LIST1, LB_RESETCONTENT , 0, (LPARAM) NULL);
				i = GetDlgItemInt(hDlg, IDC_COMBO_ELMB, NULL, NULL);
				pdo_data[0]=0; 
				pdo_data[1]=0;

				SetDlgItemText(hDlg, IDC_FESCAN_MSG, NULL);

				if (i==0)
				{
					for( i=1; i<128; ++i ) // to set all nodes!!
					 send_can_msg( CanInterface, i, PDO4TX_OBJ, TRUE, 4, pdo_data);
				}
				else send_can_msg( CanInterface, i, PDO4TX_OBJ,
			    TRUE, 4, pdo_data);

				return TRUE;
			}
			break;
			case ID_RESET:
			{
				int *lpTranslated;
				byte can_data[2];
				int i;
				i = GetDlgItemInt(hDlg, IDC_COMBO_ELMB, NULL, NULL);
				can_data[0] = NMT_RESET_NODE; //reset node
				can_data[1] = NodeID;
				can_data[1] = i; //added line (send reset to all nodes)
				send_can_msg( CanInterface, 0, NMT_OBJ, FALSE, 2, can_data );
				//printf( "Sent NMT-Reset-Node All Nodes...\n\n" ); //###modified NodeID were 0 (tutti)
				return TRUE;
			}
			break;
			case ID_RESET_COMM:
			{
				int node_id;
				node_id = GetDlgItemInt(hDlg, IDC_COMBO_ELMB, NULL, NULL);
				byte can_data[2];
				can_data[0] = NMT_RESET_COMMUNICATION;
				can_data[1] = NodeID; // to a specific node
				can_data[1] = node_id;  // to all nodes 
				send_can_msg( CanInterface, 0, NMT_OBJ, FALSE, 2, can_data );
				return TRUE;
			}
			break;
			case IDC_SET_HB:
			{						
				byte can_data[2];
				int i, heartbeat_time, node_id;
				i = GetDlgItemInt(hDlg, IDC_COMBO_ELMB, NULL, NULL);				
				heartbeat_time = GetDlgItemInt(hDlg, IDC_HEARTBEAT, NULL, NULL);

				if((heartbeat_time<=255) & (heartbeat_time>=0))
				{ 
					can_data[0] = SDO_INITIATE_DOWNLOAD_REQ| SDO_EXPEDITED;//SDO_INITIATE_UPLOAD_REQ;//for writing>> SDO_INITIATE_DOWNLOAD_REQ| SDO_EXPEDITED;
					can_data[1] = 0x17;
					can_data[2] = 0x10;
					can_data[3] = 0x00;
					can_data[4] = heartbeat_time&0xFF; //LOW heartbeat time in seconds
					can_data[5] = (heartbeat_time>>8)&0xFF; //HI heartbeat time in seconds
					//if( !get_sdo_reply( CanInterface, NodeID, pdo_data ) ) return FALSE; //this function is usend only it is expeted a reply from slave
					for( node_id=1; node_id<128; ++node_id ) // to set all nodes!!
						 send_can_msg( CanInterface, node_id, SDORX_OBJ, FALSE, 8, can_data);
				}
				else MessageBox(NULL, "HeartBeat time must be between 0 and 255", "Warning!", 1);
			//printf("Heartbeat time set to %d seconds\n", heartbeat_time);
			}
			break;
			case ID_EMB_SCAN:
			{
				int i;
				byte can_data[4];
				SendDlgItemMessage(hDlg, IDC_COMBO_ELMB, CB_RESETCONTENT, 0, (LPARAM) NULL);
				SetDlgItemInt(hDlg, IDC_COMBO_ELMB, 0, FALSE);
				SendDlgItemMessage(hDlg, IDC_COMBO_ELMB, CB_ADDSTRING, 0, (LPARAM) "00");
				SetDlgItemText(hDlg, IDC_FESCAN_MSG, NULL);
				can_data[0] = SDO_INITIATE_UPLOAD_REQ;
				can_data[1] = 0x00;
				can_data[2] = 0x10;
				can_data[3] = 0x00;
				for( i=1; i<128; ++i ) // to set all nodes!!
					 send_can_msg( CanInterface, i, SDORX_OBJ,
									FALSE, 8, can_data);	
				return TRUE;
			}
			break;
			case ID_TH_SCAN:
			{
				int node_id = GetDlgItemInt(hDlg, IDC_COMBO_ELMB, NULL, NULL);
				int time = GetDlgItemInt(hDlg, IDC_TH_SCAN_TIME, NULL, NULL); // in milliseconds

				ThreadClass thread;
				thread.run_cardiac_find_th_zero(node_id, time);

				return TRUE;
			}
			break;

			case IDC_SET_TH: //read values (offset) from file and set the threshold asked
			{
				FILE *f;
				int i2c_addr, fe_addr, node_id, i, value;
				char * str = new char[100/*47*/];
				HWND hEdit = GetDlgItem(hDlg, IDC_FESCAN_MSG);
				Dialog dialog;
				int thr_reg_ch[16];
				//HWND hEdit1 = GetDlgItem(hDlg, IDC_TH_FC); //threshold in fC
				//HWND hEdit2 = GetDlgItem(hDlg, IDC_SENSIT);//sensitivity in mV/fC
				//int node_id = GetDlgItemInt(hDlg, IDC_NODE_ID, NULL, NULL);

				if (!IsDlgButtonChecked(hDlg, IDC_RADIO3)) //setting in fC
				{
					if (FE_Array[0] == 0xAA)
					{
						MessageBox(NULL, "To use this feature you must do a 'FE Scan'\r\nRemember to 'Sent to Operational' the CANnode", "WRONG PARAMETER", MB_ICONEXCLAMATION | MB_OK);
						break;
					}											
				}				

				for( node_id=1; node_id<=64; ++node_id ) //set all FE channels
				{					
					if(FE_Array[node_id]==0) continue;
					for( i2c_addr=0; i2c_addr<=2; ++i2c_addr )
					{
						for( fe_addr=0; fe_addr<=7; ++fe_addr )
						{
							if ((FE_Array[node_id]>>(i2c_addr*8))&(1<<fe_addr))
							{
								int offset; //value of threhsold zero
								int ch, dlg_addr;
								float sensit, threshold; //user must give the sensitinity in mV/fC and the threshold in fC
								div_t n;
								GetDlgItemText(hDlg, IDC_SENSIT, str, 10);
								sscanf(str, "%f", &sensit);
								
								//if (SendMessage(hEdit2, /*(UINT)*/ BM_GETCHECK, 0, 0)) //CARDIAC_MWPC
								if (IsDlgButtonChecked(hDlg, IDC_RADIO4))
								{
									sprintf(str, "C:/LHCbTests/CARDIAC_MWPC/ELMB%02d_I2C%d_DLG%02d.xls", node_id, i2c_addr, (fe_addr+0x30));
									dialog.get_threshold_reg(TRUE, thr_reg_ch);
								}
								else //CARDIAC_GEM
								{
									sprintf(str, "C:/LHCbTests/CARDIAC_GEM/ELMB%02d_I2C%d_DLG%02d.xls", node_id, i2c_addr, (fe_addr+0x30));
									dialog.get_threshold_reg(FALSE, thr_reg_ch);
								}

								if (!IsDlgButtonChecked(hDlg, IDC_RADIO3))
								{
									f = fopen(str, "r"); 
									if(f==NULL) //check if file exist
									{
										MessageBox(NULL, "File does not exist\r\nRun calibration (TH Scan) procedure before setting the Threshold\r\nor use the third option which sets absolute values", "FILE MISSING", MB_ICONEXCLAMATION | MB_OK);
										break;
									}								

									for( i=0; i<=5; ++i ) //jump some strings in file
									{
										fscanf(f, "%s", str); 
									}
								}

								for( i=0; i<=15; ++i ) //channels
								{									
									if (!IsDlgButtonChecked(hDlg, IDC_RADIO3))
									{
										if (i!=0)
										{
											fscanf(f, "%d", &offset); //jump 2 lines
											fscanf(f, "%d", &offset);
										}
										fscanf(f, "%d", &offset); //reads the values from files >> threshold register value																		
									}
										
									if ((offset<=40)|(offset>=85))
									{
										offset = 0; //not to interfir on the next conditions
										//sprintf(str, "BAD CHANNEL node_id=%d i2c_ch=%d fe_addr=%d channel=%d\r\n", node_id, i2c_addr, fe_addr, ch);
										//SendMessage(hEdit, EM_REPLACESEL, (WPARAM) FALSE, (LPARAM)str);
									}

									if (IsDlgButtonChecked(hDlg, IDC_RADIO1)) //setting in fC
									{
										GetDlgItemText(hDlg, IDC_TH_FC, str, 10);
										sscanf(str, "%f", &threshold);
										offset = floor(offset + (sensit*(threshold-3))/DIALOG_DAC_STEP); // or something like round (the difference is minimum)											
									}
									else if (IsDlgButtonChecked(hDlg, IDC_RADIO2)) //setting in mV
									{
										GetDlgItemText(hDlg, IDC_TH_MV, str, 10);
										sscanf(str, "%f", &threshold);
										offset = floor(offset + threshold/DIALOG_DAC_STEP);
									}
									else //setting in mV
									{
										GetDlgItemText(hDlg, IDC_TH_MV2, str, 10);
										sscanf(str, "%f", &threshold);
										offset = floor(threshold/DIALOG_DAC_STEP);
									}

									if (offset > 255)
									{
										MessageBox(NULL, "Threshold value must be lower", "INVALID VALUE", MB_ICONEXCLAMATION | MB_OK);
										break;
									}										
									dlg_addr=((0x50+i2c_addr)*256)+(fe_addr+0x30);
									message_[0]=offset;
									COP_WriteSDO (CanInterface, node_id, 1, dlg_addr, thr_reg_ch[i]/*(21+ch)*/, 1, message_,can_msg_cnf);
										
								}
								if (!IsDlgButtonChecked(hDlg, IDC_RADIO3)) fclose(f);
							}
						}
					}
				}
				return TRUE;
			}
			break;
			
			case IDC_WRITE_DEFAULT: //write default values to CARDIAC registers
			{						//without changing threshold registers
				int i2c_addr, fe_addr, node_id, reg, dlg_addr;
				if (FE_Array[0] == 0xAA)
				{
					MessageBox(NULL, "To use this feature you must do a 'FE Scan'\r\nRemember to 'Sent to Operational' the CANnode", "WRONG PARAMETER", MB_ICONEXCLAMATION | MB_OK);
					break;
				}

				for( node_id=1; node_id<=64; ++node_id ) //set all FE channels
				{					
					if(FE_Array[node_id]==0) continue;
					for(i2c_addr=0; i2c_addr<=2; ++i2c_addr)
					{
						for(fe_addr=0; fe_addr<=7; ++fe_addr)
						{
							if ((FE_Array[node_id]>>(i2c_addr*8))&(1<<fe_addr))
							{
								for(reg=0; reg<=92; ++reg)
								{
									dlg_addr=((0x50+i2c_addr)*256)+(fe_addr+0x30);
									message_[0]=7;
									if(reg<=15) COP_WriteSDO (CanInterface, node_id, 1, dlg_addr, reg, 1, message_,can_msg_cnf);
									message_[0]=0xFF;
									if(reg==16|reg==17) COP_WriteSDO (CanInterface, node_id, 1, dlg_addr, reg, 1, message_,can_msg_cnf);
									if(reg==42|reg==43) COP_WriteSDO (CanInterface, node_id, 1, dlg_addr, reg, 1, message_,can_msg_cnf);
									message_[0]=8;
									if(reg==39) COP_WriteSDO (CanInterface, node_id, 1, dlg_addr, reg, 1, message_,can_msg_cnf);
									message_[0]=32;
									if(reg==40|reg==41) COP_WriteSDO (CanInterface, node_id, 1, dlg_addr, reg, 1, message_,can_msg_cnf);
									message_[0]=0;
									if(reg==18|reg>=44) COP_WriteSDO (CanInterface, node_id, 1, dlg_addr, reg, 1, message_,can_msg_cnf);
								}
							}
						}
					}
				}
				return TRUE;
			}
			break;

			case IDC_PROGRAM_ELMB:
			{
				SetDlgItemText(hDlg, IDC_FESCAN_MSG, NULL); //Clear textbox
				program_atmega_API(CanInterface, 60/*node_id*/, 0, 0);
				return TRUE;
			}
			
			case ID_CLEAR:
			{
				SetDlgItemText(hDlg, IDC_FESCAN_MSG, NULL); //Clear textbox					
				return TRUE;
			}
			break;
			case IDC_BKN_CH:
			{				
				FILE *f;
				int i2c_addr, fe_addr, node_id, i, value;
				char * str = new char[100/*47*/];
				HWND hEdit = GetDlgItem(hDlg, IDC_FESCAN_MSG);
				
				//HWND hEdit1 = GetDlgItem(hDlg, IDC_TH_FC); //threshold in fC
				//HWND hEdit2 = GetDlgItem(hDlg, IDC_SENSIT);//sensitivity in mV/fC
				//int node_id = GetDlgItemInt(hDlg, IDC_NODE_ID, NULL, NULL);

				if (FE_Array[0] == 0xAA)
				{
					MessageBox(NULL, "To use this feature you must do a 'FE Scan'\r\nRemember to 'Sent to Operational' the CANnode", "WRONG PARAMETER", MB_ICONEXCLAMATION | MB_OK);
					break;
				}

				for( node_id=1; node_id<=64; ++node_id ) //set all FE channels
				{					
					if(FE_Array[node_id]==0) continue;
					for( i2c_addr=0; i2c_addr<=2; ++i2c_addr )
					{
						for( fe_addr=0; fe_addr<=7; ++fe_addr )
						{
							if ((FE_Array[node_id]>>(i2c_addr*8))&(1<<fe_addr))
							{
								int offset; //value of threhsold zero
								int ch, dlg_addr;
								float sensit, threshold; //user must give the sensitinity in mV/fC and the threshold in fC
								div_t n;		

								//old
								//sprintf(str, "C:/LHCbTests/ELMB%02d_I2C%d_DLG%02d.xls", node_id, i2c_addr, (fe_addr+0x30));
								
								//if (SendMessage(hEdit2, /*(UINT)*/ BM_GETCHECK, 0, 0)) //CARDIAC_MWPC
								if (IsDlgButtonChecked(hDlg, IDC_RADIO4))
								{
									sprintf(str, "C:/LHCbTests/CARDIAC_MWPC/ELMB%02d_I2C%d_DLG%02d.xls", node_id, i2c_addr, (fe_addr+0x30));
								}
								else //CARDIAC_GEM
								{
									sprintf(str, "C:/LHCbTests/CARDIAC_GEM/ELMB%02d_I2C%d_DLG%02d.xls", node_id, i2c_addr, (fe_addr+0x30));
								}

								f = fopen(str, "r"); 

								if(f==NULL) //check if file exist
								{
									MessageBox(NULL, "File does not exist\r\nRun first calibration (TH Scan) procedure", "FILE MISSING", MB_ICONEXCLAMATION | MB_OK);
									break;
								}

								for( i=0; i<=5; ++i ) //jump some strings in file
								{
									fscanf(f, "%s", str); 
								}

								for( i=0; i<=45; ++i )
								{										
									fscanf(f, "%d", &offset); //reads the values from files >> threshold register value																		
									n = div(i, 3);
									if(n.rem==0)
									{
										if (IsDlgButtonChecked(hDlg, IDC_RADIO4)) //CARDIAC MWPC
										{
										   if(fmod(n.quot, 2)==0) ch = (14-(i/3)); //channel inversion (due to CARDIAC board error) even
										   else ch = i/3;
										}
										else //CARDIAC GEM
										{
											if(fmod(n.quot, 2)==1) ch = (16-(i/3)); //channel inversion (due to CARDIAC board error) odd
											else ch = i/3;
										}
										if ((offset<=40)|(offset>=85))
										{
											sprintf(str, "BAD CHANNEL node_id=%d i2c_ch=%d fe_addr=%d channel=%d\r\n", node_id, i2c_addr, fe_addr, ch);
											SendMessage(hEdit, EM_REPLACESEL, (WPARAM) FALSE, (LPARAM)str);
										}
									}
								}
							}
						}
					}
				}
				return TRUE;
			}
			break;
			case IDC_FILE_OFFSET:
			{				
				create_offset_file();
				return TRUE;
			}
			break;
			case ID_OPC_PVSS:
			{			
				if (FE_Array[0] == 0xAA)
				{
					MessageBox(NULL, "To use this feature you must do a 'FE Scan'\r\nRemember to 'Sent to Operational' the CANnode", "WRONG PARAMETER", MB_ICONEXCLAMATION | MB_OK);
					break;
				}
				create_opc_file();
				return TRUE;
			}
			break;
			break;

			case IDEXIT:
				ShowWindow(hDlg, SW_HIDE);
				//DestroyWindow(hDlg);
				//EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			break;

		}
	}
    return FALSE;
}

// Mesage handler for CARDIAC box.
LRESULT CALLBACK CardiacReadWrite(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	BYTE can_msg_cnf[4];
	BYTE message_[4];
	BYTE can_msg_rtn[4];
	WORD len;
	WORD index_actel=0x4700;

	switch (message)
	{
		case WM_INITDIALOG:
		{
			int node_id, i, j;
			char * str = new char[10];
			//set comboBoxes
			//SetDlgItemText(hDlg, IDC_COMBO_ELMB, "0");
			for(i=1; i<=64; i++)
			{
				if (i<=9) sprintf(str, "0%d", i);
				else sprintf(str, "%d", i);
				SendDlgItemMessage(hDlg, IDC_COMBO_ELMB, CB_ADDSTRING, 0, 
								(LPARAM) str);				
			}
			for(i=0; i<=2; i++)
			{
				for(j=0; j<=7; j++)
				{
					sprintf(str, "I2C%d_FE%d", i, j);
					SendDlgItemMessage(hDlg, IDC_COMBO_CARDIAC, CB_ADDSTRING, 0, 
									(LPARAM) str);
				}
			}
			SendDlgItemMessage(hDlg, IDC_COMBO_TSTMODE, CB_ADDSTRING, 0, 
									(LPARAM) "1-disabled");
			SendDlgItemMessage(hDlg, IDC_COMBO_TSTMODE, CB_ADDSTRING, 0, 
									(LPARAM) "2-ASD pulse mode");
			SendDlgItemMessage(hDlg, IDC_COMBO_TSTMODE, CB_ADDSTRING, 0, 
									(LPARAM) "3-counter start/stop");
			SendDlgItemMessage(hDlg, IDC_COMBO_TSTMODE, CB_ADDSTRING, 0, 
									(LPARAM) "4-pattern gen.");

			SendDlgItemMessage(hDlg, IDC_COMBO_PHCOMB, CB_ADDSTRING, 0, 
									(LPARAM) "1-L0=(P0orP1)");
			SendDlgItemMessage(hDlg, IDC_COMBO_PHCOMB, CB_ADDSTRING, 0, 
									(LPARAM) "2-L0=(P0orP1orP2orP3)");
			SendDlgItemMessage(hDlg, IDC_COMBO_PHCOMB, CB_ADDSTRING, 0, 
									(LPARAM) "3-L0=(P0orP1orP2orP3orP4orP5orP6orP7)");
			SendDlgItemMessage(hDlg, IDC_COMBO_PHCOMB, CB_ADDSTRING, 0, 
									(LPARAM) "4-L0=(P0andP1)");
			SendDlgItemMessage(hDlg, IDC_COMBO_PHCOMB, CB_ADDSTRING, 0, 
									(LPARAM) "5-L0=(P0andP1)or(P2andP3)");
			SendDlgItemMessage(hDlg, IDC_COMBO_PHCOMB, CB_ADDSTRING, 0, 
									(LPARAM) "6-L0=(P0andP1)or(P2andP3)or(P4andP5)or(P6andP7)");
			for(i=0; i<=15; i++)
			{
				if(i<=9)sprintf(str, "0%d", i);
				else sprintf(str, "%d", i);
				if(fmod(i, 2)==0)				
					SendDlgItemMessage(hDlg, IDC_COMBO_CHTOSC0, CB_ADDSTRING, 0, 
									(LPARAM) str);
				else
					SendDlgItemMessage(hDlg, IDC_COMBO_CHTOSC1, CB_ADDSTRING, 0, 
									(LPARAM) str);
			}		

			//write to combobox FEaddr

			for( node_id=1; node_id<=64; ++node_id ) //set all FE channels
				{					
					if(FE_Array[node_id]==0) continue;
					for( i=0; i<=2; ++i )//i2c_addr
					{
						for( j=0; j<=7; ++j )//fe_addr
						{
							if ((FE_Array[node_id]>>(i*8))&(1<<j))
							{
								sprintf(str, "NodeID%02d_I2C%d_FE%d",node_id, i, j);
								SendDlgItemMessage(hDlg, IDC_FE_COMBOBOX, CB_ADDSTRING, 0, (LPARAM) str);
							}
						}
					}
				}			
			
		}
				return TRUE;

		case WM_COMMAND:
		{		
			switch(LOWORD(wParam))
			{
				case ID_DFT_VALUES:
				{
					Dialog dialog;
					int i2c_addr, reg;
					int a, b, fe_addr, node_id;
					char * str1 =  new char[20];
					bool test = 30;
					
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a, &b);
					fe_addr = ((0x50+a)*256)+(0x30+b);

					if(!dialog.set_default(node_id, a, b/*fe_addr*/))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}
					
					SendMessage(hDlg, WM_COMMAND, (WPARAM)ID_READ_ALL , (LPARAM)NULL);
					return TRUE;
				}
				break;
				case ID_READ_ALL:
				{
					int dato;
					unsigned int dato2;
					int i;
					int a, b, fe_addr, node_id;
					char * str1 =  new char[20];
					HWND hEdit;
					bool test;
					Dialog dialog;
					int th_phch[16];					

					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a, &b);
					fe_addr = ((0x50+a)*256)+(0x30+b);

					for(i=0; i<=15; i++) //Delay+Shaper
					{
						if (test=COP_ReadSDO (CanInterface,node_id,1, fe_addr,i,&len,can_msg_rtn,can_msg_cnf))
						dato = can_msg_rtn[0];
						else
						{
							MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
							break;
						}
						sprintf(str1, "%d", (dato>>3));
						SetDlgItemText(hDlg, IDC_EDIT_DELAY0+i, str1);
						sprintf(str1, "%d", (dato&0x7));
						SetDlgItemText(hDlg, IDC_EDIT_SHAPER0+i, str1);
					}
					if (test == FALSE) break;	
					
					COP_ReadSDO (CanInterface,node_id,1, fe_addr,16,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];

					for(i=0; i<=7; i++) //mask
					{
						hEdit = GetDlgItem(hDlg, IDC_CHECK17+(i+8));
						if((dato>>i)&1) 
							SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) NULL); 
						else
							SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_UNCHECKED, (LPARAM) NULL); 
						//if((dato>>i)&1) CheckRadioButton(hDlg, IDC_CHECK1+(i+8),IDC_CHECK1+(i+8),IDC_CHECK1+(i+8));
					}

					COP_ReadSDO (CanInterface,node_id,1, fe_addr,17,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];
					for(i=0; i<=7; i++) //mask
					{
						hEdit = GetDlgItem(hDlg, IDC_CHECK17+i);
						if((dato>>i)&1) 
							SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) NULL); 
						else
							SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_UNCHECKED, (LPARAM) NULL); 
						//if((dato>>i)&1) CheckRadioButton(hDlg, IDC_CHECK1+i,IDC_CHECK1+i,IDC_CHECK1+i);
					}
					COP_ReadSDO (CanInterface,node_id,1, fe_addr,18,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];
					if (dato==0xF8) SetDlgItemText(hDlg, IDC_COMBO_PHCOMB, "1-L0=(P0orP1)");
					else if (dato==0xF9) SetDlgItemText(hDlg, IDC_COMBO_PHCOMB, "2-L0=(P0orP1orP2orP3)");
					else if (dato==0xFA) SetDlgItemText(hDlg, IDC_COMBO_PHCOMB, "3-L0=(P0orP1orP2orP3orP4orP5orP6orP7)");
					else if (dato==0xFC) SetDlgItemText(hDlg, IDC_COMBO_PHCOMB, "4-L0=(P0andP1)");
					else if (dato==0xFD) SetDlgItemText(hDlg, IDC_COMBO_PHCOMB, "5-L0=(P0andP1)or(P2andP3)");
					else if (dato==0xFE) SetDlgItemText(hDlg, IDC_COMBO_PHCOMB, "6-L0=(P0andP1)or(P2andP3)or(P4andP5)or(P6andP7)");
					else SetDlgItemText(hDlg, IDC_COMBO_PHCOMB, "NO MEANING");//NO MEANING

					//read thresholds and set dlgitem (panel) in the right order (based on physical channel ordering)
					if (IsDlgButtonChecked(g_hElmbDialog, IDC_RADIO4)) dialog.get_threshold_reg(TRUE, th_phch); //CARDIAC MWPC
					else dialog.get_threshold_reg(FALSE, th_phch); //CARDIAC GEM
					for(i=0; i<=15; i++) //thresholds
					{
						//if (COP_ReadSDO (CanInterface,node_id,1, fe_addr,ADDR_CARI0+i,&len,can_msg_rtn,can_msg_cnf))
						//dato = can_msg_rtn[0];
						if (COP_ReadSDO (CanInterface,node_id,1, fe_addr,th_phch[i],&len,can_msg_rtn,can_msg_cnf))
						dato = can_msg_rtn[0];
						else
						{
							MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
							break;
						}
						dato = ceil(dato*DIALOG_DAC_STEP);
						sprintf(str1, "%d", dato);
						SetDlgItemText(hDlg, IDC_EDIT_TH0+i, str1);
					}
					if (dato == -1) break;
					COP_ReadSDO (CanInterface,node_id,1, fe_addr,37,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];
					sprintf(str1, "%d", dato);
					SetDlgItemText(hDlg, IDC_EDIT_DLL0, str1);
					COP_ReadSDO (CanInterface,node_id,1, fe_addr,38,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];
					sprintf(str1, "%d", dato);
					SetDlgItemText(hDlg, IDC_EDIT_DLL1, str1);
					COP_ReadSDO (CanInterface,node_id,1, fe_addr,39,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];
					if ((dato==0xF1)|(dato==0xF9)) SetDlgItemText(hDlg, IDC_COMBO_TSTMODE, "2-ASD pulse mode");
					else if ((dato==0xF2)|(dato==0xFA)) SetDlgItemText(hDlg, IDC_COMBO_TSTMODE, "3-counter start/stop");
					else if ((dato==0xF3)|(dato==0xFB)) SetDlgItemText(hDlg, IDC_COMBO_TSTMODE, "4-pattern gen.");
					else if ((dato==0xF4)|(dato==0xFC)) SetDlgItemText(hDlg, IDC_COMBO_TSTMODE, "5-Calibration DLL");
					else SetDlgItemText(hDlg, IDC_COMBO_TSTMODE, "1-disabled");
					
					hEdit = GetDlgItem(hDlg, IDC_CHECK_ASD0);
					COP_ReadSDO (CanInterface,node_id,1, fe_addr,40,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];					
					if((dato>>5)&1) SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) NULL);
					else SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_UNCHECKED, (LPARAM) NULL);
					//dato = ceil(dato*DIALOG_DAC_STEP);
					sprintf(str1, "%d", dato&0x1F);
					SetDlgItemText(hDlg, IDC_EDIT_ASD0, str1);

					hEdit = GetDlgItem(hDlg, IDC_CHECK_ASD1);
					COP_ReadSDO (CanInterface,node_id,1, fe_addr,41,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];
					if((dato>>5)&1) SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) NULL);
					else SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_UNCHECKED, (LPARAM) NULL);
					sprintf(str1, "%d", dato&0x1F);
					SetDlgItemText(hDlg, IDC_EDIT_ASD1, str1);

					COP_ReadSDO (CanInterface,node_id,1, fe_addr,42,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];
					for(i=0; i<=7; i++) //pattern
					{
						hEdit = GetDlgItem(hDlg, IDC_CHECK1+(i+8));
						if((dato>>i)&1)// CheckRadioButton(hDlg, IDC_CHECK17+(i+8),IDC_CHECK17+(i+8),IDC_CHECK17+(i+8));
							SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) NULL); 
						else
							SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_UNCHECKED, (LPARAM) NULL);
					}
					COP_ReadSDO (CanInterface,node_id,1, fe_addr,43,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];
					for(i=0; i<=7; i++) //pattern
					{
						hEdit = GetDlgItem(hDlg, IDC_CHECK1+i);
						if((dato>>i)&1) //CheckRadioButton(hDlg, IDC_CHECK17+i,IDC_CHECK17+i,IDC_CHECK17+i);
							SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_CHECKED, (LPARAM) NULL); 
						else
							SendMessage(hEdit, (UINT) BM_SETCHECK, (WPARAM) BST_UNCHECKED, (LPARAM) NULL); 
					}
					COP_ReadSDO (CanInterface,node_id,1, fe_addr,44,&len,can_msg_rtn,can_msg_cnf);
					dato = can_msg_rtn[0];//((dato&7)*2) (((dato*16)&7)*2)+1
					if(((dato&7)*2)<=9) sprintf(str1, "0%d", ((dato&7)*2));
					else sprintf(str1, "%d", ((dato&7)*2));
					SetDlgItemText(hDlg, IDC_COMBO_CHTOSC0, str1);
					if((((dato>>4)&7)*2)+1<=9) sprintf(str1, "0%d", (((dato>>4)&7)*2)+1);
					else sprintf(str1, "%d", (((dato>>4)&7)*2)+1);
					SetDlgItemText(hDlg, IDC_COMBO_CHTOSC1, str1);


					for(i=0; i<=15; i++) //Counters
					{
						COP_ReadSDO(CanInterface,node_id, 1, fe_addr,ADDR_SCAL_BASE_MSB + (i*3),&len,can_msg_rtn,can_msg_cnf);
						dato2=can_msg_rtn[0]*65536+can_msg_rtn[1]*256+can_msg_rtn[2];
						sprintf(str1, "%d", dato2);
						SetDlgItemText(hDlg, IDC_EDIT_SCALER0+i, str1);						
					}

					return TRUE;
				}				
				break; 

				case IDC_TEST_COUNT:
				{
					int dato;
					//unsigned int dato2;
					//int i;
					//int a, b, fe_addr, node_id;
					//char * str1 =  new char[20];
					HWND hEdit;
					bool test;

					char * str1 =  new char[20];
					int a, b, fe_addr, node_id;
					int i, time;
					unsigned int dato2, TMIS;
					BYTE message_[4];


					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a, &b);
					fe_addr = ((0x50+a)*256)+(0x30+b);


					//reset ch counter
					for(i=0; i<=15; i++)
					{
						message_[0] = 0x00;
						if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, (ADDR_SCAL_BASE_MSB+(i*3)), 1, message_,can_msg_cnf))
						{
							MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
							break;
						}
					}

					//set sw_start_stop ACTEL mode	
					message_[0]=INT_PULSE;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_TEST_PULSE_SEL, 1, message_,can_msg_cnf);	
					message_[0]=SW_START_STOP;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_INT_PULSE_SEL, 1, message_,can_msg_cnf);			


					{ //this part garantees enable counter is (disable)
						message_[0]=SW_PULSE;
						COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_INT_PULSE_SEL, 1, message_,can_msg_cnf);
						//pattern 0xFFFF
						message_[0]=0xFF;
						COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_PATTERNMSB, 1, message_,can_msg_cnf);
						COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_PATTERNLSB, 1, message_,can_msg_cnf);
						//set DLG to START/STOP mode
						/*
						message_[0]=TSTMODCFG_STARTSTOPMODE;
						COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf);
							//send pulse start/stop
						message_[0]=0x1;
						COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);
						*/

						message_[0]=TSTMODCFG_PATMODE;
						COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf);
						message_[0]=0x1;
						COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);//pulse1
						COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);//pulse2
						COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);//pulse3
						COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);//pulse4
						COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);//pulse5

						/*
						message_[0]=TSTMODCFG_STARTSTOPMODE;
						COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf);

						message_[0]=0x1;
						COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);//stop
						message_[0]=TSTMODCFG_PATMODE;
						COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf);
						message_[0]=0x1;
						COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);//pulse1
						COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);//pulse2
						*/

						dato2 = 0;
						//read counters 
						COP_ReadSDO(CanInterface,node_id, 1, fe_addr,(ADDR_SCAL_BASE_MSB + (0*3)),&len,can_msg_rtn,can_msg_cnf);
						dato2=can_msg_rtn[0]*65536+can_msg_rtn[1]*256+can_msg_rtn[2];		//ch (above)
						//reading another channel in case the last one is bad...
						COP_ReadSDO(CanInterface,node_id, 1, fe_addr,(ADDR_SCAL_BASE_MSB + (1*3)),&len,can_msg_rtn,can_msg_cnf);
						dato2=dato2+(can_msg_rtn[0]*65536+can_msg_rtn[1]*256+can_msg_rtn[2]);
					
						//printf("count =	%d\n", dato2);
						if (dato2!=0)  // put dialog in STOP
						{
							message_[0]=TSTMODCFG_STARTSTOPMODE;
							COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf);
							message_[0]=0x1;
							COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf); //stop
						}
					}

					//set DLG to START/STOP mode
					message_[0]=TSTMODCFG_STARTSTOPMODE;
					COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf);


					//set sw_start_stop ACTEL mode	
					message_[0]=INT_PULSE;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_TEST_PULSE_SEL, 1, message_,can_msg_cnf);	
					message_[0]=SW_START_STOP;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_INT_PULSE_SEL, 1, message_,can_msg_cnf);
				//	message_[0]=0x1;
				//	COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);


					//set TMIS to time ms
					time = 1000; // time in ms
					TMIS= ((time*1000000)/25)-1;
					message_[0]=TMIS & 0xff;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_TMIS_L, 1, message_,can_msg_cnf);
					message_[0]=(TMIS >> 8 ) & 0xff;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_TMIS_H, 1, message_,can_msg_cnf);
					message_[0]=(TMIS >> 16 ) & 0xff;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_ACTEL_PRESCAL_L, 1, message_,can_msg_cnf);
					message_[0]=(TMIS >> 24 ) & 0xff;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_ACTEL_PRESCAL_H, 1, message_,can_msg_cnf);


					
					
					
					//reset ch counter
					for(i=0; i<=15; i++)
					{
						message_[0] = 0x00;
						if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, (ADDR_SCAL_BASE_MSB+(i*3)), 1, message_,can_msg_cnf))
						{
							MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
							break;
						}
					}

					//send start stop pulses
					message_[0]=0x1;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_PULSE, 1, message_,can_msg_cnf);
					//wait
					Sleep(time);





					for(i=0; i<=15; i++) //Counters
					{
						if(!COP_ReadSDO(CanInterface,node_id, 1, fe_addr,ADDR_SCAL_BASE_MSB + (i*3),&len,can_msg_rtn,can_msg_cnf))
						{
							MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections (bug expected)", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
							break;
						}
						dato2=can_msg_rtn[0]*65536+can_msg_rtn[1]*256+can_msg_rtn[2];
						sprintf(str1, "%d", dato2);
						SetDlgItemText(hDlg, IDC_EDIT_SCALER0+i, str1);						
					}

					return TRUE;
				}
				break;


				case ID_SET1:
				{
					char * str1 =  new char[20];
					int list, list1;
					bool test;
					int a, b, fe_addr, node_id;

					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a, &b);
					fe_addr = ((0x50+a)*256)+(0x30+b);

					GetDlgItemText(hDlg, IDC_COMBO_TSTMODE, str1, 20);
					sscanf(str1, "%d", &list);
					message_[0]=(list-1);
					if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}

					GetDlgItemText(hDlg, IDC_COMBO_PHCOMB, str1, 20);
					sscanf(str1, "%d", &list);
					message_[0]=(list-1);
					if (list<=2) message_[0]=(list-1);
					else message_[0]=list;
					test = COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_LCHGEN, 1, message_,can_msg_cnf);
					if(test == FALSE)
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}

					GetDlgItemText(hDlg, IDC_COMBO_CHTOSC0, str1, 20);
					sscanf(str1, "%02d", &list);
					GetDlgItemText(hDlg, IDC_COMBO_CHTOSC1, str1, 20);
					sscanf(str1, "%02d", &list1);
					list = ((((list1/2)+0.5)*16) + (list/2));
					message_[0]=list;
					if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_SCALSEL, 1, message_,can_msg_cnf))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}


					return TRUE;
				}
				break;
				case ID_SET2:
				{
					Dialog dialog;
					char * str1 = new char[100/*47*/];
					int th[16], threshold;
					int i, j, fe_addr, node_id;

					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &i, &j);
					fe_addr = ((0x50+i)*256)+(0x30+j);

					if(!IsDlgButtonChecked(hDlg, IDC_CHECK_ALLTH))
					{
						for(i=0; i<=15; i++)
						{
						  //get threshold value
							GetDlgItemText(hDlg, IDC_EDIT_TH0+i, str1, 10);
							sscanf(str1, "%d", &threshold);							
							th[i] = threshold;
							//write to CARDIAC
							if(!dialog.set_threshold_mV(node_id, fe_addr, th))
							{
							  MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
							  break;
							}
						}
					}
					else
					{
						//get threshold value
						GetDlgItemText(hDlg, IDC_EDIT_TH0, str1, 10);
						sscanf(str1, "%d", &threshold);
						for(i=0; i<=15; i++)
						{
							th[i] = threshold;
						}
						//write to CARDIAC
						if(!dialog.set_threshold_mV(node_id, fe_addr, th))
						{
							MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
							break;
						}
						
					}

					return TRUE;
				}
				break;
				case ID_SET3:
				{
					char * str1 = new char[20];
					int a, b, fe_addr, node_id;
					bool test;
					int value1, value2, nID;

					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a, &b);
					fe_addr = ((0x50+a)*256)+(0x30+b);

					
					if(!IsDlgButtonChecked(hDlg, IDC_CHECK_ALLDS))
					{					
						for(nID=0;nID<=15;nID++)
						{
							GetDlgItemText(hDlg, IDC_EDIT_DELAY0+nID, str1, 10);
							sscanf(str1, "%d", &value1);
							GetDlgItemText(hDlg, IDC_EDIT_SHAPER0+nID, str1, 10);
							sscanf(str1, "%d", &value2);
							value1 = ((value1&31)<<3)+(value2&7);
							message_[0] = value1;
							if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, (ADDR_DELAYSHAPER0/*0*/+nID), 1, message_,can_msg_cnf))
							{
								MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
								break;
							}
						}
					}
					else
					{
						GetDlgItemText(hDlg, IDC_EDIT_DELAY0, str1, 10);
						sscanf(str1, "%d", &value1);
						GetDlgItemText(hDlg, IDC_EDIT_SHAPER0, str1, 10);
						sscanf(str1, "%d", &value2);
						value1 = ((value1&31)<<3)+(value2&7);					
						for(nID=0;nID<=15;nID++)
						{
							message_[0] = value1;
							if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, (ADDR_DELAYSHAPER0/*0*/+nID), 1, message_,can_msg_cnf))
							{
								MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
								break;
							}
						}
					}
					return TRUE;
				}
				break;
				case ID_SET4:
				{
					Dialog dialog;
					char * str1 = new char[20];
					int i, j, fe_addr, node_id, i2c_ch;
					bool ch[16];

					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &i2c_ch, &fe_addr);					

					//read check (psttern) list and write to dialog register
					for(i=0;i<=15;i++)
					{
						if(IsDlgButtonChecked(hDlg, IDC_CHECK1+i)) ch[i] = TRUE;
						else ch[i] = FALSE;
					}
					if(!dialog.set_pattern(node_id, i2c_ch, fe_addr, ch))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}

					//read check (mask) list and write to dialog register
					for(i=0;i<=15;i++)
					{
						if(IsDlgButtonChecked(hDlg, IDC_CHECK17+i)) ch[i] = TRUE;
						else ch[i] = FALSE;
					}
					if(!dialog.set_mask(node_id, i2c_ch, fe_addr, ch))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}
			
					return TRUE;
				}
				break;
				case ID_SET5:
				{
					char * str1 = new char[20];
					int a, b, fe_addr, node_id;
					bool test;
					int value1;

					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a, &b);
					fe_addr = ((0x50+a)*256)+(0x30+b);

					GetDlgItemText(hDlg, IDC_EDIT_DLL0, str1, 10);
					sscanf(str1, "%d", &value1);
					message_[0] = value1;
					if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_DLL0DAC, 1, message_,can_msg_cnf))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}

					GetDlgItemText(hDlg, IDC_EDIT_DLL1, str1, 10);
					sscanf(str1, "%d", &value1);
					message_[0] = value1;
					if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_DLL1DAC, 1, message_,can_msg_cnf))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}
					
					return TRUE;
				}
				break;
				case ID_SET6:
				{
					char * str1 = new char[20];
					int a, b, fe_addr, node_id;
					bool test;
					int value1;

					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a, &b);
					fe_addr = ((0x50+a)*256)+(0x30+b);

					GetDlgItemText(hDlg, IDC_EDIT_ASD0, str1, 10);
					sscanf(str1, "%d", &value1);
					if(IsDlgButtonChecked(hDlg, IDC_CHECK_ASD0)) value1 = value1+32;
					message_[0] = value1;
					if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_PLSMSKDLY0, 1, message_,can_msg_cnf))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}

					GetDlgItemText(hDlg, IDC_EDIT_ASD1, str1, 10);
					sscanf(str1, "%d", &value1);
					if(IsDlgButtonChecked(hDlg, IDC_CHECK_ASD1)) value1 = value1+32;
					message_[0] = value1;
					if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_PLSMSKDLY1, 1, message_,can_msg_cnf))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}


					return TRUE;
				}
				break;
				case ID_RESET_SCALERS:
				{
					char * str1 = new char[100/*47*/];
					int threshold, ch;
					int a, b, fe_addr, node_id;
					bool test;

					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a, &b);
					fe_addr = ((0x50+a)*256)+(0x30+b);

					for(ch=0; ch<=15; ch++)
					{
						message_[0] = 0x00;
						if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, (ADDR_SCAL_BASE_MSB+(ch*3)), 1, message_,can_msg_cnf))
						{
							MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
							break;
						}
					}					
					return TRUE;
				}
				break;
				case ID_DLL_CALIB:
				{
					char * str1 = new char[100/*47*/];
					int threshold, ch;
					int a, b, fe_addr, node_id;
					bool test;

					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a, &b);
					fe_addr = ((0x50+a)*256)+(0x30+b);

					//stop 40MHz (just in case)
					message_[0]=REG_PULSE;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_TEST_PULSE_SEL, 1, message_,can_msg_cnf);							

					message_[0] = 4;
					if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}
					//start 40MHz
					message_[0]=CLK40;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_TEST_PULSE_SEL, 1, message_,can_msg_cnf);
					Sleep(1000);
					message_[0] = 0;
					COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf);
					//stop 40MHz
					message_[0]=REG_PULSE;
					COP_WriteSDO (CanInterface, node_id, 1, index_actel, ADDR_TEST_PULSE_SEL, 1, message_,can_msg_cnf);

					return TRUE;
				}
				break;
				case ID_SET_STARTSTOP:
				{
					char * str1 =  new char[20];
					bool test;
					int a, b, fe_addr, node_id;
					BYTE dato;

					//get node_id and fe_addr
					GetDlgItemText(hDlg, IDC_FE_COMBOBOX, str1, 18);
					sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a, &b);
					fe_addr = ((0x50+a)*256)+(0x30+b);

					if(COP_ReadSDO (CanInterface,node_id,1, fe_addr,ADDR_TSTMODCFG,&len,can_msg_rtn,can_msg_cnf))
					dato = can_msg_rtn[0];
					else
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}
					message_[0] = 0;
					if(!COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf))
					{
						MessageBox(hDlg, "ELMB specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}
					message_[0] = 2;
					COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf);

					message_[0] = dato;
					if (dato !=2) COP_WriteSDO (CanInterface, node_id, 1, fe_addr, ADDR_TSTMODCFG, 1, message_,can_msg_cnf);


					return TRUE;
				}
				break;
				
				case IDEXIT:
				{
					DestroyWindow(hDlg);
					//EndDialog(hDlg, LOWORD(wParam));
					return TRUE;
				}
				break;
			}
		}
		break;
	}
    return FALSE;
}



// Mesage handler for TestStation box.
LRESULT CALLBACK TestStationProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	BYTE can_msg_cnf[4];
	BYTE message_[4];
	BYTE can_msg_rtn[4];
	WORD len;
	WORD index_actel=0x4700;
	char * str1 = new char[20];
	int node_id, i2c_ch;

	
	
	switch (message)
	{
		case 1:
		{
			GetDlgItemText(hDlg, IDC_TS_COMBOBOX, str1, 18);
			sscanf(str1, "NodeID%02d_I2C", &node_id);
		}

		case WM_INITDIALOG:

		{
			int node_id, i, j;
			char * str = new char[10];
			//write to combobox TSaddr
			for( node_id=1; node_id<=64; ++node_id ) //set all FE channels
			{					
				if(ELMB_Array[node_id]==0) continue;
				for( i=0; i<=2; ++i )//i2c_addr
				{
					sprintf(str, "NodeID%02d_I2C%d",node_id, i);
					SendDlgItemMessage(hDlg, IDC_TS_COMBOBOX, CB_ADDSTRING, 0, (LPARAM) str);
				}
			}
		}
			return TRUE;

		case WM_COMMAND:
		{		

			GetDlgItemText(hDlg, IDC_TS_COMBOBOX, str1, 18);
			//sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id, &a);
			sscanf(str1, "NodeID%02d_I2C%d", &node_id, &i2c_ch);


			switch(LOWORD(wParam))
			{
				case IDC_TS_DAC:
				{
					Test_Station ts; 
					BYTE DAC_value;

					DAC_value = GetDlgItemInt(hDlg, IDC_DAC_VALUE, NULL, NULL);
					if(!ts.write_dac(node_id, i2c_ch, DAC_value))
					{	
						MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}
					
					return TRUE;
				}
				break;

				case IDC_TS_ADC:
				{
					Test_Station ts;
					BYTE ADC_value = 0;
					BYTE data[4];
					char * str =  new char[20];

					if(!ts.read_adc(node_id, i2c_ch, &ADC_value))
					{
						MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}

					sprintf(str, "%d", ADC_value);
					SetDlgItemText(hDlg, IDC_ADC_VALUE, str);

					return TRUE;
				}
				break;

				case IDC_TS_MASK:
				{
					int MASK_value;
					BYTE data[4];
					//SetDlgItemText(hDlg, IDC_DAC_VALUE, str1);
					MASK_value = GetDlgItemInt(hDlg, IDC_MASK_VALUE, NULL, NULL);
					//info TEST_STATION_DAC_ADDR = 0x4F

					data[0] = MASK_value &0xff; //I2C data bytes U32
					data[1] = (MASK_value>>8)  &0xff;
					data[2] = 0;
					data[3] = 0;

					if(!write_i2c(node_id, i2c_ch, TEST_STATION_MASK_ADDR<<1, 2, data))
					{	
						MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}

					return TRUE;
				}
				break;

				case IDC_SET_40M:
				{
					Sb_Actel sb_ac;

					if(!sb_ac.send_40M_clk(node_id))
					{	
						MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}
				
					return TRUE;
				}
				break;

				case IDC_SEND_PULSE:
				{
					Sb_Actel sb_ac;

					if(!sb_ac.send_long_pulse(node_id))
					{	
						MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}

					return TRUE;
				}
				break; 

				case IDC_SEND_1000PULSES:
				{
					Sb_Actel sb_ac;

					if(!sb_ac.send_1000long_pulse(node_id))
					{	//											 i2c0_addr0x9E			output enalble
						MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}		
									
					return TRUE;
				}
				break;

				case ID_READ_TSSCALERS:
				{
					Test_Station ts;
					int index;
					WORD rxlen;
					int value = 0;
					BYTE data[4], len;
					char * str =  new char[20];

					//-------------------read counter 0 ------------------------//
					ts.read_counter(node_id, i2c_ch, 0, &value);					
					sprintf(str, "%d", value);
					SetDlgItemText(hDlg, IDC_EDIT_TSSCALER0, str);

					//-------------------read counter 1 ------------------------//
					ts.read_counter(node_id, i2c_ch, 1, &value);					
					sprintf(str, "%d", value);
					SetDlgItemText(hDlg, IDC_EDIT_TSSCALER1, str);

					//-------------------read counter 2 ------------------------//
					ts.read_counter(node_id, i2c_ch, 2, &value);					
					sprintf(str, "%d", value);
					SetDlgItemText(hDlg, IDC_EDIT_TSSCALER2, str);

					//-------------------read counter 3 ------------------------//
					ts.read_counter(node_id, i2c_ch, 3, &value);					
					sprintf(str, "%d", value);
					SetDlgItemText(hDlg, IDC_EDIT_TSSCALER3, str);

					//-------------------read counter 4 ------------------------//
					ts.read_counter(node_id, i2c_ch, 4, &value);					
					sprintf(str, "%d", value);
					SetDlgItemText(hDlg, IDC_EDIT_TSSCALER4, str);

					//-------------------read counter 5 ------------------------//
					ts.read_counter(node_id, i2c_ch, 5, &value);					
					sprintf(str, "%d", value);
					SetDlgItemText(hDlg, IDC_EDIT_TSSCALER5, str);

					//-------------------read counter 6 ------------------------//
					ts.read_counter(node_id, i2c_ch, 6, &value);					
					sprintf(str, "%d", value);
					SetDlgItemText(hDlg, IDC_EDIT_TSSCALER6, str);

					//-------------------read counter 7 ------------------------//
					ts.read_counter(node_id, i2c_ch, 7, &value);					
					sprintf(str, "%d", value);
					SetDlgItemText(hDlg, IDC_EDIT_TSSCALER7, str);

					return TRUE;
				}
				break;

				case IDC_TS_START:
				{
					Test_Station ts;

					if(!ts.start_counters(node_id, i2c_ch))											
					{	
						MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}

					return TRUE;
				}
				break;

				case IDC_TS_STOP:
				{
					Test_Station ts;

					if(!ts.stop_counters(node_id, i2c_ch))											
					{	
						MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}					

					return TRUE;
				}
				break;

				case ID_RESET_TSSCALERS:
				{
					Test_Station ts;

					if(!ts.reset_counters(node_id, i2c_ch))
					{	
						MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						break;
					}					

					return TRUE;
				}
				break;

				case IDEXIT:
				{
					DestroyWindow(hDlg);
					//EndDialog(hDlg, LOWORD(wParam));					
					return TRUE;
				}
				break;
			}
		}
		break;
		case IDEXIT:
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		break;
	}
	return FALSE;
}



// Message handler for Scurve box.
LRESULT CALLBACK ScurveProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static graph2D testing;
	int node_id_inj, node_id_cb, node_id_fe;
	int i2c_ch_inj, i2c_ch_cb, i2c_ch_fe;
	char * str1 = new char[20];
	
	switch (message)
	{
		return TRUE;
		case WM_INITDIALOG:
		{
			int i, j, node_id;
			char * str = new char[10];
			HWND hPicture = GetDlgItem(hDlg, IDC_PICTURE_STATIC);
			testing.select_frame(hPicture); //select frame where will be draw the xy graphic
			testing.update();
			{ //find avaibles i2c channels and write it to combo_box			  
			  //write to combobox TSaddr
			  for( node_id=1; node_id<=64; ++node_id ) //set all FE channels
			  {					
				 if(ELMB_Array[node_id]==0) continue;
				 for( i=0; i<=2; ++i )//i2c_addr
				 {
					sprintf(str, "NodeID%02d_I2C%d",node_id, i);
					SendDlgItemMessage(hDlg, IDC_SC_COMBOBOX, CB_ADDSTRING, 0, (LPARAM) str);
				 }
			  }			
			}

			for( node_id=1; node_id<=64; ++node_id ) //set all FE channels
			{					
				if(FE_Array[node_id]==0) continue;
				for( i=0; i<=2; ++i )//i2c_addr
				{
					for( j=0; j<=7; ++j )//fe_addr
					{
						if ((FE_Array[node_id]>>(i*8))&(1<<j))
						{
							sprintf(str, "NodeID%02d_I2C%d_FE%d",node_id, i, j);
							SendDlgItemMessage(hDlg, IDC_SC_COMBOBOX_FE_ADDR, CB_ADDSTRING, 0, (LPARAM) str);
						}
					}
				}
			}

			SendDlgItemMessage(hDlg, IDC_SPIN1, UDM_SETRANGE, 0,MAKELPARAM(255, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN2, UDM_SETRANGE, 0,MAKELPARAM(255, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN3, UDM_SETRANGE, 0,MAKELPARAM(255, 1));
			SendDlgItemMessage(hDlg, IDC_SPIN4, UDM_SETRANGE, 0,MAKELPARAM(15, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN5, UDM_SETRANGE, 0,MAKELPARAM(600, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN6, UDM_SETRANGE, 0,MAKELPARAM(600, 0));
			SetDlgItemInt(hDlg, IDC_SCURVE_STEP, 1, FALSE);

			CheckRadioButton(hDlg, IDC_RADIO2, IDC_RADIO3, IDC_RADIO2); //set value default
		}
		return TRUE;
		case WM_PAINT:
		{		
			//testing.update();
		}
		break;

		case WM_COMMAND:
		{	
			int fe_addr;
			{
			   int a, b;
			   // fe_addr
			   GetDlgItemText(hDlg, IDC_SC_COMBOBOX_FE_ADDR, str1, 18);
			   sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id_fe, &i2c_ch_fe, &fe_addr);

			   // test_station addr
			   GetDlgItemText(hDlg, IDC_SC_COMBOBOX, str1, 18);
			   sscanf(str1, "NodeID%02d_I2C%d", &node_id_inj, &i2c_ch_inj);
			}

			switch(LOWORD(wParam))
			{
				case ID_SCURVE: //routine to do scurve
				{	
					ThreadClass thread;
					HANDLE hThread;
					hThread = thread.run_scurve();
					//WaitForSingleObject(hThread, 10000);
					
				/*	int value, init, end, step, i, inj_ch;
					bool ch_mask[16];
					Sb_Actel sb_ac;
					Test_Station ts;
					Dialog dialog;

					init = GetDlgItemInt(hDlg, IDC_SCURVE_INIT, NULL, NULL);
					end = GetDlgItemInt(hDlg, IDC_SCURVE_END, NULL, NULL);
					step = GetDlgItemInt(hDlg, IDC_SCURVE_STEP, NULL, NULL);
					inj_ch = GetDlgItemInt(hDlg, IDC_SC_CHANNEL, NULL, NULL);

					//set default
					if(!dialog.set_default(node_id_fe, i2c_ch_fe, fe_addr))
					{	
					  MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
					  break;
					}

					//set DIALOG MASK to this channel (inj_ch)
					for(i=0;i<=15;i++) ch_mask[i] = FALSE;
					ch_mask[inj_ch] = TRUE;					
					if(!dialog.set_mask(node_id_fe, i2c_ch_fe, fe_addr, ch_mask))
					{	
					  MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
					  break;
					}

					//set TS MASK (PCF8575) to this channel (inj_ch)
					if(!ts.set_mask(node_id_inj, i2c_ch_inj, ch_mask))
					{	
					  MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
					  break;
					}

					for(i=init; i<= end; i+=step)
					{
						SetDlgItemInt(hDlg, IDC_CURRENT_VALUE, i, FALSE);
						//set DAC value
						if(!ts.write_dac(node_id_inj, i2c_ch_inj, i))
						{	
						  MessageBox(hDlg, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
						  break;
						}
						
					    //reset counters						
					    ts.reset_counters(node_id_inj, i2c_ch_inj);

					    //send 1000 pulses
					    sb_ac.send_1000long_pulse(node_id_inj);

					    //read counters
					    ts.read_counter(node_id_inj, i2c_ch_inj, floor(inj_ch/2), &value); //ch3				

					    testing.add_point(value, 10);
					    testing.update();
					}
					
					/*for(i=0; i<=10; i++)
					{
						Sleep(1000);
					  testing.y1[10*i]=10*i;
					  testing.update();
					}*/		
					
					return TRUE;
				}
				break;
				case ID_CLEAR:
				{	
					int ch;
					Dialog dialog;
					_beginthread( Bounce, 0, (void *) (ch++));
					//_beginthread((void *) dialog.set_default(node_id_fe, i2c_ch_fe, 0), 0, NULL);
					//testing.clear();			
					//testing.update();		
					return TRUE;
				}
				break;	
				case IDC_SC_SET_TH:
				{			
					Dialog dialog;
					int ch = GetDlgItemInt(hDlg, IDC_SC_CHANNEL, NULL, NULL);
					//if RadioButton ON
					int th_mV = GetDlgItemInt(hDlg, IDC_TH_MV, NULL, NULL);
					dialog.set_th_mV_plus_offset(node_id_fe, i2c_ch_fe, fe_addr, TRUE, ch, th_mV);					
					return TRUE;
				}
				break;
				case IDEXIT:
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;
				break;
			}
		}
		break;
	}
	return FALSE;
}












LRESULT CALLBACK	CANopen_TextOut(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	return 0;
}


HWND CreateNewMDIChild(HWND hMDIClient)
{
	MDICREATESTRUCT mcs;
	//HWND hChild;
	mcs.szTitle = "CAN messages";
	mcs.szClass = g_szChildClassName;
	mcs.hOwner = GetModuleHandle(NULL);
	mcs.x = mcs.cx = CW_USEDEFAULT;
	mcs.y = mcs.cy = CW_USEDEFAULT;
	mcs.style = MDIS_ALLCHILDSTYLES;

	if(hChild)
		hChild = (HWND)SendMessage(hChild, WM_CLOSE, 0, 0);
	
	hChild = (HWND)SendMessage(hMDIClient, WM_MDICREATE, 0, (LONG)&mcs);
	if (!hChild)
		MessageBox(hMDIClient, "MDI Client creation failed", "&&&", MB_ICONEXCLAMATION | MB_OK);

	return hChild;
}

void Bounce( void *ch )
{		
			int value, init, end, step, i, inj_ch, j;
			bool ch_mask[16];
			Sb_Actel sb_ac;
			Test_Station ts;
			Dialog dialog;
			static graph2D testing;// it was static before maybe...
			extern HWND g_hScurveDialog;
			int fe_addr, node_id_fe, i2c_ch_fe, node_id_inj, i2c_ch_inj;
			HWND hPicture = GetDlgItem(g_hScurveDialog, IDC_PICTURE_STATIC);
			testing.select_frame(hPicture);
			char * str1 = new char[20];
			BYTE data[4];
				BYTE can_msg_cnf[4];

			{
			   int a, b;
			   // fe_addr
			   GetDlgItemText(g_hScurveDialog, IDC_SC_COMBOBOX_FE_ADDR, str1, 18);
			   sscanf(str1, "NodeID%02d_I2C%d_FE%d", &node_id_fe, &i2c_ch_fe, &fe_addr);

			   // test_station addr
			   GetDlgItemText(g_hScurveDialog, IDC_SC_COMBOBOX, str1, 18);
			   sscanf(str1, "NodeID%02d_I2C%d", &node_id_inj, &i2c_ch_inj);
			}

			init = GetDlgItemInt(g_hScurveDialog, IDC_SCURVE_INIT, NULL, NULL);
			end = GetDlgItemInt(g_hScurveDialog, IDC_SCURVE_END, NULL, NULL);
			step = GetDlgItemInt(g_hScurveDialog, IDC_SCURVE_STEP, NULL, NULL);
			inj_ch = GetDlgItemInt(g_hScurveDialog, IDC_SC_CHANNEL, NULL, NULL);

			//set default
			if(!dialog.set_default(node_id_fe, i2c_ch_fe, fe_addr))
			{	
			  MessageBox(g_hScurveDialog, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
			  //return FALSE;
			}

			//set DIALOG MASK to this channel (inj_ch)
			for(i=0;i<=15;i++) ch_mask[i] = FALSE;
			ch_mask[inj_ch] = TRUE;					
			if(!dialog.set_mask(node_id_fe, i2c_ch_fe, fe_addr, ch_mask))
			{	
			  MessageBox(g_hScurveDialog, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
			  //return FALSE;
			}

			//set TS MASK (PCF8575) to this channel (inj_ch)
			if(!ts.set_mask(node_id_inj, i2c_ch_inj, ch_mask))
			{	
			  MessageBox(g_hScurveDialog, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
			  //return FALSE;
			}

			for(i=init; i<= end; i+=step)
			{
				SetDlgItemInt(g_hScurveDialog, IDC_CURRENT_VALUE, i, FALSE);
				//set DAC value
				if(!ts.write_dac(node_id_inj, i2c_ch_inj, i))
				{	
				  MessageBox(g_hScurveDialog, "Device specified does not exist\r\nVerify if you are using the right ELMB address or/and the node connections", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
				  ///return FALSE;
				}
						
			    //reset counters						
			    ts.reset_counters(node_id_inj, i2c_ch_inj);
		    
				
				//send 1000 pulses
				if(!sb_ac.send_1000long_pulse(node_id_inj))
				{	
				  MessageBox(g_hScurveDialog, "sb_ac.send_1000long_pulse func fail", "WRONG PARAMETER", MB_OK | MB_ICONERROR);
				  ///return FALSE;
				}

/*				data[0]=SW_PULSE;
	if(!COP_WriteSDO (CanInterface, node_id_inj, 1, 0x4700, ADDR_INT_PULSE_SEL, 1, data,can_msg_cnf));

	data[0]=REG_PULSE;
	if(!COP_WriteSDO (CanInterface, node_id_inj, 1, 0x4700, ADDR_TEST_PULSE_SEL, 1, data,can_msg_cnf));
		//											 i2c0_addr0x9E			output enalble					
	data[0]=0x0;
	if(!COP_WriteSDO (CanInterface, node_id_inj, 1, 0x4700, ADDR_PULSE, 1, data,can_msg_cnf));

	for(j=0; j<=99;j++)
	{		
		data[0]=0x1;
		if(!COP_WriteSDO (CanInterface, node_id_inj, 1, 0x4700, ADDR_PULSE, 1, data,can_msg_cnf));
		data[0]=0x0;
		if(!COP_WriteSDO (CanInterface, node_id_inj, 1, 0x4700, ADDR_PULSE, 1, data,can_msg_cnf));
	}*/
	



			    //sb_ac.send_1000long_pulse(node_id_inj);
				

			    //read counters
			    ts.read_counter(node_id_inj, i2c_ch_inj, floor(inj_ch/2), &value); //ch3				

			    testing.add_point(value, 10);
			    testing.update();
			}	
					
			//return TRUE;
		}		
